#	include	"Standard.h"

static	char
UpperCase(char	ch)
	{
	if((ch>='a')&&(ch<='z'))
		return(ch-'a'+'A');
	return(ch);
	}

static	bool
AreEqual(
	char	*s1,
	char	*s2)
	{
	while((*s1)&&(*s2))
		{
		if(UpperCase(*s1)!=UpperCase(*s2))
			return(false);
		++s1;
		++s2;
		}
	if(*s1)
		return(false);
	if(*s2)
		return(false);
	return(true);
	}

bool
PrintHelp(
	CommandLineArgument	*cla)
	{
	printf("Parameters are set by using -Parameter:value strings.\n");
	printf("  value can be in any reasonable form\n");
	printf("  The following parameters are available (case insensitive):\n");
	int		Index = 0;
	char	s[128];

	int		*iType;
	uint	*uType;
	bool	*bType;
	char	*sType;
	double	*dType;
	int64	*llType;

	sprintf(s, "  %30s:<filename>\n", "-Source");
	printf("%s", s);
	while ( cla[Index].Name )
		{
		sprintf(s, "-%s", cla[Index].Name);
		printf("  %30s:", s);
		switch(cla[Index].Type)
			{
			case	claInteger:		printf("number   ");break;
			case	clauInteger:	printf("unumber  ");break;
			case	claBool:		printf("bool     ");break;
			case	claString:		printf("string   ");break;
			case	claDouble:		printf("double   ");break;
			case	claInt64:		printf("int64    ");break;
			default:
				printf("error");
			}
		printf("default=");
		iType = (int*) cla[Index].Ptr;
		uType = (uint*) cla[Index].Ptr;
		bType = (bool*) cla[Index].Ptr;
		sType = (char*) cla[Index].Ptr;
		dType = (double*) cla[Index].Ptr;
		llType = (int64 *) cla[Index].Ptr;

		switch(cla[Index].Type)
			{
			case	claInteger:	printf("%10d  (0x%8.8x)", *iType, *iType);break;
			case	clauInteger:printf("%10u  (0x%8.8x)", *uType, *uType);break;
			case	claBool:
				if(*bType)
					printf("true");
				else
					printf("false");
				break;
			case	claString: printf("%s", sType); break;
			case	claDouble: printf("%f", (double) *dType);break;
			case	claInt64: printf("%lld", (int64) *llType);break;
			default:
				printf("error");
			}
		printf("\n");
		++Index;
		}
	return(true);
	}

static	bool
LocateAndSetArgument(
	CommandLineArgument	*cla,
	char				*Parameter,
	char				*Value)
	{
	int		Index = 0;

	int		*iType;
	uint	*uType;
	bool	*bType;
	char	*sType;
	double	*dType;
	int64	*llType;

	while ( cla[Index].Name )
		{
		if(AreEqual(Parameter, cla[Index].Name))
			{
			iType = (int*) cla[Index].Ptr;
			uType = (uint*) cla[Index].Ptr;
			bType = (bool*) cla[Index].Ptr;
			sType = (char*) cla[Index].Ptr;
			dType = (double*) cla[Index].Ptr;
			llType = (int64*) cla[Index].Ptr;

			switch(cla[Index].Type)
				{
				case	claInteger:
					if((Value[1]=='x')||(Value[1]=='X'))
						(*iType) = (int)strtol(Value, NULL, 16);
					else
						(*iType) = (int)strtol(Value, NULL, 10);
					break;
				case	clauInteger:
					if((Value[1]=='x')||(Value[1]=='X'))
						(*uType) = (uint)strtoul(Value, NULL, 16);
					else
						(*uType) = (uint)strtoul(Value, NULL, 10);
					break;
				case	claBool:
					if(AreEqual(Value, "false"))
						(*bType) = false;
					else
					if(AreEqual(Value, "true"))
						(*bType) = true;
					else
					if(AreEqual(Value, "no"))
						(*bType) = false;
					else
					if(AreEqual(Value, "yes"))
						(*bType) = true;
					else
					if(Value[0] == '0')
						(*bType) = false;
					else
					if(Value[0] == '1')
						(*bType) = true;
					else
						{
						printf("Error decoding boolean: \"%s\"\n", Value);
						return(-1);
						}
					break;
				case	claString:
					strcpy(sType, Value);
					break;
				case	claDouble:
					(*dType) = atof(Value);
					break;
				case	claInt64:
					(*llType) = atoll(Value);
					break;
				default:
					printf("error: mal-formed CLA %s\n", cla[Index].Name);
				}
			return(true);
			}
		++Index;
		}
	printf("Parameter %s is not found try -h\n", Parameter);
	return(false);
	}

static	int
SourceInputFile(
	CommandLineArgument	*cla,
	char	*filename)
	{
	FILE	*fp = fopen(filename, "r");
	char	s[1024];

	if(!fp)
		{
		printf("Could not open source input: %s\n", filename);
		return(1);
		}
	fgets(s, 1024, fp);
	while(!feof(fp))
		{
		if(s[0]=='#')
			{
			fgets(s, 1024, fp);
			continue;
			}
		while(s[0])
			{
			if((s[0]==' ')||(s[0]=='\t')||(s[0]=='-'))
				{
				memcpy(&s[0], &s[1], strlen(s));
				continue;
				}
			break;
			}
		if(strlen(s)<=1)
			{
			fgets(s, 1024, fp);
			continue;
			}
		s[strlen(s)-1] = '\0';

		char	*field = strchr(s, ':');
		if(!field)
			{
			printf("Malformed argument: %s\n", s);
			fclose(fp);
			return(-1);
			}
		(*field) = '\0';
		++field;
		if(!(*field))
			{
			printf("Malformed argument: %s\n", s);
			fclose(fp);
			return(-1);
			}
		if(!strcmp(s, "Source"))
			{
			SourceInputFile(cla, field);
			fgets(s, 1024, fp);
			continue;
			}
		if(!LocateAndSetArgument(cla, s, field))
			{
			printf("Notfound/Malformed argument: %s:%s\n", s, field);
			fclose(fp);
			return(-1);
			}
		
		fgets(s, 1024, fp);
		}
	fclose(fp);
	return(0);
	}

int
ParseCommandLine(
	CommandLineArgument	*cla,
	int					argc,
	char				*argv[])
	{
	int		vargc = 1;
	char	s[1024];
	while (vargc < argc)
		{
		if((argv[vargc][0]=='-')||(argv[vargc][1]=='/'))
			{
			if(AreEqual(&argv[vargc][1], "h"))
				{
				PrintHelp(cla);
				exit(1);
				return(-1);
				}
			strcpy(s, &argv[vargc][1]);

			char	*field = strchr(s, ':');
			if(!field)
				{
				printf("Malformed argument: %s\n", argv[vargc]);
				exit(2);
				return(-1);
				}
			(*field) = '\0';
			++field;
			if(!(*field))
				{
				printf("Malformed argument: %s\n", argv[vargc]);
				exit(2);
				return(-1);
				}
			if(!strcmp(s, "Source"))
				{
				SourceInputFile(cla, field);
				++vargc;
				continue;
				}
			if(!LocateAndSetArgument(cla, s, field))
				{
				printf("Notfound/Malformed argument: %s\n", argv[vargc]);
				exit(2);
				return(-1);
				}
			++vargc;
			}
		else
			break;
			
		}
	return(vargc);
	}

bool
DumpParameters(
	CommandLineArgument		*cla,
	FILE					*fp)
	{
	int		Index = 0;
	char	s[128];

	int		*iType;
	uint	*uType;
	bool	*bType;
	char	*sType;
	double	*dType;
	int64	*llType;

	while ( cla[Index].Name )
		{
		sprintf(s, "-%s", cla[Index].Name);
		fprintf(fp, "  %40s:", s);
		iType = (int*) cla[Index].Ptr;
		uType = (uint*) cla[Index].Ptr;
		bType = (bool*) cla[Index].Ptr;
		sType = (char*) cla[Index].Ptr;
		dType = (double*) cla[Index].Ptr;
		llType = (int64 *) cla[Index].Ptr;

		switch(cla[Index].Type)
			{
			case	claInteger:	fprintf(fp, "%d", *iType, *iType);break;
			case	clauInteger:fprintf(fp, "%u", *uType, *uType);break;
			case	claBool:
				if(*bType)
					fprintf(fp, "true");
				else
					fprintf(fp, "false");
				break;
			case	claString: fprintf(fp, "%s", sType); break;
			case	claDouble: fprintf(fp, "%f", (double) *dType);break;
			case	claInt64: fprintf(fp, "%lld", (int64) *llType);break;
			default:
				printf("error");
			}
		fprintf(fp, "\n");
		++Index;
		}
	return(true);
	}

