typedef	struct	_SpeculativelyCompletedInstruction
	{
	int64				theInstructionNumber;
	double				Confidence;
	int64				DependentUpon0;
	int64				DependentUpon1;
	}	SpeculativelyCompletedInstruction;

class	CompletionUnit
	{
	public:
		int64			PredictionCount;
	public:
		int				MaxCompletionsPerCycle;
		int				CompletedThisCycle;
		int64			Completed;
		Array<int64>	CompletedInstructions;
		Array<SpeculativelyCompletedInstruction>		Predictions;
		Array<SpeculativelyCompletedInstruction>		FollowUpInstructions;
	public:
		bool	Initialize (int	aMaxCompletionsPerCycle);
		bool	CompleteInstruction (
			int64		InstructionCount,
			double		Confidence = 1.0,
			int64		DependentUpon0 = (-1),
			int64		DependentUpon1 = (-1),
			bool		MustComplete = false);
		bool	Flush(int64	ToInstruction);
		bool	IsCompletedWithNoSpeculation(
					int64	theInstruction);
		bool	IsCompleted(
					int64	theInstruction,
					bool	UsePredicted = false,
					bool	*Speculatively = NULL,
					double	*Confidence = NULL);
		bool	IsCompletedWithConfidence(
					int64	theInstruction,
					double	WithConfidence,
					double	*theConfidence = NULL);
		bool	SimulateOneClock ();
		bool	CompletePrediction(
			int64	InstructionCount,
			double	Confidence);
	private:
		bool		CompleteFollowUpInstructions();

			
	};

