
// This is a conventional Fetch Unit
// no trace-cache is implemented.  It has the ability
// to fetch n contigious instructions.

class	FetchUnit
	{
	public:
		uint		Address;
		uint		Stalled;
		uint		FetchProgramCounter;
		bool		FetchingIncorrectly;
		BasicBlock	*theCode;
		BasicBlock	*CurrentBlock;
		uint		L1MissPenalty;
		uint		L2MissPenalty;
		int64		CorrectBranchPredictions;
		int64		IncorrectBranchPredictions;
		int64		EnsureHit;
		int64		FreeHits;

		BasicBlock	*FindBasicBlock(uint	Address);

		bool	Initialize (
					BasicBlock	*CodeSpace,
					uint		aL1MissPenalty,
					uint		aL2MissPenalty);
		bool	SimulateOneClock(
					Instruction	*Instructions,
					uint		*Addresses,
					int			*FetchedInstructions,
					int			MaxFetchSize);
		bool	ResetFetchProgramCounter(uint	NewAddress);
		bool	EnsureCacheHit(int64);
		int		StallsDueToCache(NormalDistribution l1, NormalDistribution l2);
	};
