#	include	"Standard.h"

double
RandomVariable::GetUniformRandomVariable (
	double	range)
	{
	double	x = (rand() & 0x7fffffff);
	double	y = 0x7fffffff;

	return((x*range)/y);
	}

// Borrowed from Numerical Recipies in C
double
RandomVariable::GetNormalRandomVariable (
	double	u,
	double	o)
	{
	static	int	Choose = 0;		// static stuff is just an optimization...
	static	double	TempValue;
	double	Factor, RootSquare, v1, v2;

	do
		{
		v1 = (2.0*GetUniformRandomVariable(1.0) - 1.0);
		v2 = (2.0*GetUniformRandomVariable(1.0) - 1.0);
		RootSquare = v1* v1 + v2 * v2;
		}
	while ( RootSquare >= 1.0 || RootSquare == 0.0 );

	Factor = sqrt( -2.0 * log(RootSquare) / (RootSquare) );
	TempValue = o*(v1*Factor)+u;
	Choose = 1;
	return(o*(v2 * Factor)+u);
	}

double
RandomVariable::GetExponentialRandomVariable(
	double	l)
	{
	double	temp;

	do
		{
		temp = GetUniformRandomVariable(1.0);
		}
	while ( temp == 0.0 );

	return( -1.0 * log(temp) / l );
	}

bool
RandomVariable::InitializeRandomVariableGenerator(
	int	Seed)
	{
	if(Seed == 0)
		srand(time(NULL)+getpid());
	else
		srand(Seed);
	return ( true );
	}

