#	include	"Standard.h"

// Simple code generator
// later on, need to make a function that reads in a parameter
// file and produces some code that is tunable.
// but for now, we just need something to play with

#	define	DependenceCurveSize	(20+3)

char	DependenceCurveFile[1024]	=	"dep.input";
int		NumberOfBasicBlocks						=	100;
NormalDistribution	ForwardBlockJumpDistance	=	{	3,	2	};
NormalDistribution	BackBlockJumpDistance		=	{	10, 3	};
double	AverageNumberOfBackBranches				=	0.15;	// 15 percent
NormalDistribution	ForwardBranchPredictabilityu		=		{	0.85, 0.0	};
NormalDistribution	ForwardBranchPredictabilityo		=		{	0.0, 0.0	};
NormalDistribution	BackwardBranchPredictabilityu		=		{	0.85, 0.0	};
NormalDistribution	BackwardBranchPredictabilityo		=		{	0.0, 0.0	};
//ExponentialDistribution	ForwardBranchPredictability		=		{	2	};
//ExponentialDistribution	BackwardBranchPredictability	=		{	2.5	};

// Basic Block parameters
NormalDistribution		BasicBlockSize			=	{	7, 4	};

// Cache Hit/Miss behavior
NormalDistribution	L1IHu						=	{	0.98, 0.01	};
NormalDistribution	L2IHu						=	{	0.98, 0.01	};
NormalDistribution	L1IHo						=	{	0.02, 0.02	};
NormalDistribution	L2IHo						=	{	0.02, 0.02	};

NormalDistribution	L1DHu						=	{	0.90, 0.05	};
NormalDistribution	L2DHu						=	{	0.90, 0.05	};
NormalDistribution	L1DHo						=	{	0.10, 0.05	};
NormalDistribution	L2DHo						=	{	0.10, 0.05	};

// Instruction type brake down
double	PercentInteger							=	0.50;
double	PercentFloating							=	0.05;
double	PercentLoad								=	0.20;
double	PercentStore							=	0.10;
double	PercentBranch							=	0.15;

// FU Predictability: Integer
NormalDistribution	IntegerInstructionOPu		=	{	0.50, 0.10	};
NormalDistribution	IntegerInstructionOPo		=	{	0.20, 0.10	};
NormalDistribution	IntegerInstructionOPKu		=	{	0.50, 0.10	};
NormalDistribution	IntegerInstructionOPKo		=	{	0.20, 0.10	};
NormalDistribution	IntegerInstructionOPCu		=	{	0.50, 0.10	};
NormalDistribution	IntegerInstructionOPCo		=	{	0.20, 0.10	};
NormalDistribution	IntegerInstructionMu		=	{	0.50, 0.10	};
NormalDistribution	IntegerInstructionMo		=	{	0.20, 0.10	};
double	IntegerI0Curve[DependenceCurveSize];
double	IntegerI1Curve[DependenceCurveSize];

// FU Predictability: Load
NormalDistribution	LoadInstructionOPu			=	{	0.50, 0.10	};
NormalDistribution	LoadInstructionOPo			=	{	0.20, 0.10	};
NormalDistribution	LoadInstructionOPKu			=	{	0.50, 0.10	};
NormalDistribution	LoadInstructionOPKo			=	{	0.20, 0.10	};
NormalDistribution	LoadInstructionOPCu			=	{	0.50, 0.10	};
NormalDistribution	LoadInstructionOPCo			=	{	0.20, 0.10	};
double	LoadI0Curve[DependenceCurveSize];

// FU Predictability: Store
NormalDistribution	StoreInstructionOPu			=	{	0.50, 0.10	};
NormalDistribution	StoreInstructionOPo			=	{	0.20, 0.10	};
NormalDistribution	StoreInstructionOPKu		=	{	0.50, 0.10	};
NormalDistribution	StoreInstructionOPKo		=	{	0.20, 0.10	};
NormalDistribution	StoreInstructionOPCu		=	{	0.50, 0.10	};
NormalDistribution	StoreInstructionOPCo		=	{	0.20, 0.10	};
double	StoreI0Curve[DependenceCurveSize];
double	StoreI1Curve[DependenceCurveSize];

// FU Predictability: Floating Point
NormalDistribution	FPInstructionOPu			=	{	0.05, 0.02	};
NormalDistribution	FPInstructionOPo			=	{	0.03, 0.01	};
NormalDistribution	FPInstructionOPKo			=	{	0.00, 0.00	};
NormalDistribution	FPInstructionOPKu			=	{	0.00, 0.00	};
NormalDistribution	FPInstructionOPCu			=	{	0.05, 0.02	};
NormalDistribution	FPInstructionOPCo			=	{	0.03, 0.01	};
NormalDistribution	FPInstructionMu				=	{	0.05, 0.02	};
NormalDistribution	FPInstructionMo				=	{	0.03, 0.01	};
double	FPI0Curve[DependenceCurveSize];
double	FPI1Curve[DependenceCurveSize];

// Branch Cruve
double	BranchI0Curve[DependenceCurveSize];
double	BranchI1Curve[DependenceCurveSize];
NormalDistribution	BranchInstructionOPu			=	{	0.50, 0.50	};
NormalDistribution	BranchInstructionOPo			=	{	0.20, 0.20	};
NormalDistribution	BranchInstructionOPKu			=	{	0.50, 0.50	};
NormalDistribution	BranchInstructionOPKo			=	{	0.20, 0.20	};
NormalDistribution	BranchInstructionOPCu			=	{	0.50, 0.50	};
NormalDistribution	BranchInstructionOPCo			=	{	0.20, 0.20	};
NormalDistribution	BranchInstructionMu				=	{	0.50, 0.10	};
NormalDistribution	BranchInstructionMo				=	{	0.20, 0.10	};

bool
static
ParseInputCurve(
	char	*s,
	double	Curve[DependenceCurveSize])
	{
	char	*p = strchr(s, ':');
	if(!p)
		{
		printf("Invalid curve file!\n");
		exit(1);
		}
	++p;
	int		Index = 0;
	while(Index<DependenceCurveSize)
		{
		Curve[Index] = atof(p);
		p = strchr(p, ' ');
		if(!p)
			{
			printf("corrupt curve file!\n");
			exit(2);
			}
		++p;
		++Index;
		}
	return(true);
	}

bool
ReadInputCurves()
	{
	FILE	*fp = fopen(DependenceCurveFile, "r");
	if(!fp)
		{
		printf("Error opening: %s\n", DependenceCurveFile);
		exit(1);
		}
	// now, read in the file, one line at a time.
	char	s[1024];

	fgets(s, 1024, fp);ParseInputCurve(s, IntegerI0Curve);
	fgets(s, 1024, fp);ParseInputCurve(s, IntegerI1Curve);
	fgets(s, 1024, fp);ParseInputCurve(s, FPI0Curve);
	fgets(s, 1024, fp);ParseInputCurve(s, FPI1Curve);
	fgets(s, 1024, fp);ParseInputCurve(s, LoadI0Curve);
	fgets(s, 1024, fp);ParseInputCurve(s, StoreI0Curve);
	fgets(s, 1024, fp);ParseInputCurve(s, StoreI1Curve);
	fgets(s, 1024, fp);ParseInputCurve(s, BranchI0Curve);
	fgets(s, 1024, fp);ParseInputCurve(s, BranchI1Curve);
	fclose(fp);
	return(true);
	}

int
CreateInputDependence(
	double	Curve[DependenceCurveSize])
	{
	double	x = RandomVariable::GetUniformRandomVariable(100.0);

	// now decide on a curve
	double	T = 0.0;
	int		Index = 0;
	while(Index<DependenceCurveSize)
		{
		T += Curve[Index];
		if(T>=x)
			{
			//if(Index==0)
			//	return(-1);
			if(Index<(DependenceCurveSize-3))
				return(Index);
			if(Index<(DependenceCurveSize-2))
				return((int)(RandomVariable::GetUniformRandomVariable(100.0-(DependenceCurveSize-3))+
								(DependenceCurveSize-3)) );
			if(Index<(DependenceCurveSize-1))
				return((int)(RandomVariable::GetUniformRandomVariable(1000.0-(DependenceCurveSize-3))+
								(DependenceCurveSize-3)) );
			if(Index<(DependenceCurveSize))
				return((int)(RandomVariable::GetUniformRandomVariable(1000000.0-(DependenceCurveSize-3))+
								(DependenceCurveSize-3)) );
			}
		++Index;
		}
	return((int)RandomVariable::GetUniformRandomVariable(DependenceCurveSize-3));
	}

BasicBlock	*
CreateInputCode ()
	{
	int						Index = 0, Index2, Temp;
	Array<BasicBlock	*>	BasicBlocks;
	BasicBlock				*b;
	double					x;
	double					MOPu, MOPo, SOPu, SOPo;
	double					MOPKu, MOPKo, SOPKu, SOPKo;
	double					MOPCu, MOPCo, SOPCu, SOPCo;
	double					MMu, MMo, SMu, SMo;
	double					*ID0, *ID1;
	uint					Address = 0;

	// step 1: create the basic blocks.

	ReadInputCurves();

	Index = 0;
	while ( Index < NumberOfBasicBlocks )
		{
		b = new BasicBlock;
		BasicBlocks.Append(b);
		memset(b, 0, sizeof(BasicBlock));
		if(Index>0)
			BasicBlocks[Index-1]->Next = b;
		// set Memoizability
		x = -1;
		while( x < 0.0 )
			{	
			x = RandomVariable :: GetNormalRandomVariable(BranchInstructionMu);
			}
		b->MemoizabilityOfBranch.u = x;
		x = -1;
		while( x < 0.0 )
			{	
			x = RandomVariable :: GetNormalRandomVariable(BranchInstructionMo);
			}
		b->MemoizabilityOfBranch.o = x;
		b->BranchInputDependencies[0] = CreateInputDependence(BranchI0Curve);
		b->BranchInputDependencies[1] = CreateInputDependence(BranchI1Curve);
		++Index;
		}

	// step 2: bind basic blocks together via jumps

	Index = 0;
	while ( Index < (NumberOfBasicBlocks-1) )
		{
		b = BasicBlocks[Index];
		b->BranchTargets[0]	= BasicBlocks[Index+1];
		// Determine if this is a forward/backward branch
		if(RandomVariable::GetUniformRandomVariable() <= AverageNumberOfBackBranches)
			{
			// Backward Branch
			// determine branch distance
			x = Index+1;	// an invalid number
			while(
				((int)(Index - (int)x) < 0)	||
				((int)(Index - (int)x) >= NumberOfBasicBlocks)	)
				{
				x = RandomVariable::GetNormalRandomVariable(BackBlockJumpDistance);
				}
			b->BranchTargets[1] = BasicBlocks[(int)(Index -(int)x)];
			//b->BranchPredictability = RandomVariable::GetExponentialRandomVariable(
			//	BackwardBranchPredictability);
			b->BranchPredictability.u = RandomVariable::GetNormalRandomVariable(
				BackwardBranchPredictabilityu);
			b->BranchPredictability.u = RandomVariable::GetNormalRandomVariable(
				BackwardBranchPredictabilityo);
			}
		else
			{
			// Forward Branch
			x = NumberOfBasicBlocks + 1;	// an invalid number
			while(
				((int)(Index + x) >= NumberOfBasicBlocks)	||
				((int)(Index + x) < 0)	)
				{
				x = RandomVariable::GetNormalRandomVariable(ForwardBlockJumpDistance);
				}
			b->BranchTargets[1] = BasicBlocks[(int)(Index + (int)x)];
			//b->BranchPredictability = RandomVariable::GetExponentialRandomVariable(
			//	ForwardBranchPredictability);
			b->BranchPredictability.u = RandomVariable::GetNormalRandomVariable(
				ForwardBranchPredictabilityu);
			b->BranchPredictability.o = RandomVariable::GetNormalRandomVariable(
				ForwardBranchPredictabilityo);
			}
		++Index;
		}
	// Now, deal with the last one
	b = BasicBlocks[Index];
	x = RandomVariable::GetUniformRandomVariable(NumberOfBasicBlocks-1);
	b->BranchTargets[0] = BasicBlocks[(int)x];
	x = RandomVariable::GetUniformRandomVariable(NumberOfBasicBlocks-1);
	b->BranchTargets[1] = BasicBlocks[(int)x];
	b->BranchPredictability.u = RandomVariable::GetNormalRandomVariable(
		BackwardBranchPredictabilityu);
	b->BranchPredictability.o = RandomVariable::GetNormalRandomVariable(
		BackwardBranchPredictabilityo);


	// step 3: for each basic block, configure it
	Index = 0;
	while ( Index < NumberOfBasicBlocks )
		{
		b = BasicBlocks[Index];
		x = 0;
		while(x < 1)
			{
			x = RandomVariable::GetNormalRandomVariable(BasicBlockSize);
			}
		b->NumberOfInstructions = (int) x;
		b->Address = Address;
		Address += (b->NumberOfInstructions + 1);
		b->Instructions = new Instruction[b->NumberOfInstructions];
		memset(b->Instructions, 0, sizeof(Instruction)*b->NumberOfInstructions);

		Index2 = 0;
		while ( Index2 < b->NumberOfInstructions )
			{
			b->Instructions[Index2].IsJump = false;
			// step 3_a: determine type of instruction
			x = RandomVariable::GetUniformRandomVariable(1.0 - PercentBranch);
			if ( x <= PercentInteger )
				b->Instructions[Index2].FunctionalUnitRequirements = Integer;
			else
			if ( x <= (PercentInteger + PercentFloating) )
				b->Instructions[Index2].FunctionalUnitRequirements = FloatingPoint;
			else
			if ( x <= (PercentInteger + PercentFloating + PercentLoad) )
				b->Instructions[Index2].FunctionalUnitRequirements = Load;
			else
			if ( x <= (PercentInteger + PercentFloating + PercentLoad + PercentStore) )
				b->Instructions[Index2].FunctionalUnitRequirements = Store;
			else
				continue;	// ehh, retry?

			MOPKu = SOPKu = MOPKo = SOPKo = -1;
			MOPCu = SOPCu = MOPCo = SOPCo = -1;
			MOPu = SOPu = MOPo = SOPo = -1;
			MMu = SMu = MMo = SMo = -1;

			switch ( b->Instructions[Index2].FunctionalUnitRequirements )
				{
				case	Integer:
					MOPu = IntegerInstructionOPu.u;
					SOPu = IntegerInstructionOPu.o;
					MOPo = IntegerInstructionOPo.u;
					SOPo = IntegerInstructionOPo.o;
					MOPKu = IntegerInstructionOPKu.u;
					SOPKu = IntegerInstructionOPKu.o;
					MOPKo = IntegerInstructionOPKo.u;
					SOPKo = IntegerInstructionOPKo.o;
					MOPCu = IntegerInstructionOPCu.u;
					SOPCu = IntegerInstructionOPCu.o;
					MOPCo = IntegerInstructionOPCo.u;
					SOPCo = IntegerInstructionOPCo.o;
					MMu = IntegerInstructionMu.u;
					SMu = IntegerInstructionMu.o;
					MMo = IntegerInstructionMo.u;
					SMo = IntegerInstructionMo.o;
					ID0 = IntegerI0Curve;
					ID1 = IntegerI1Curve;
					break;
				case	FloatingPoint:
					MOPu = FPInstructionOPu.u;
					SOPu = FPInstructionOPu.o;
					MOPo = FPInstructionOPo.u;
					SOPo = FPInstructionOPo.o;
					MOPKu = FPInstructionOPKu.u;
					SOPKu = FPInstructionOPKu.o;
					MOPKo = FPInstructionOPKo.u;
					SOPKo = FPInstructionOPKo.o;
					MOPCu = FPInstructionOPCu.u;
					SOPCu = FPInstructionOPCu.o;
					MOPCo = FPInstructionOPCo.u;
					SOPCo = FPInstructionOPCo.o;
					MMu = FPInstructionMu.u;
					SMu = FPInstructionMu.o;
					MMo = FPInstructionMo.u;
					SMo = FPInstructionMo.o;
					ID0 = FPI0Curve;
					ID1 = FPI1Curve;
					break;
				case	Load:
					MOPu = LoadInstructionOPu.u;
					SOPu = LoadInstructionOPu.o;
					MOPo = LoadInstructionOPo.u;
					SOPo = LoadInstructionOPo.o;
					MOPKu = LoadInstructionOPKu.u;
					SOPKu = LoadInstructionOPKu.o;
					MOPKo = LoadInstructionOPKo.u;
					SOPKo = LoadInstructionOPKo.o;
					MOPCu = LoadInstructionOPCu.u;
					SOPCu = LoadInstructionOPCu.o;
					MOPCo = LoadInstructionOPCo.u;
					SOPCo = LoadInstructionOPCo.o;
					ID0 = LoadI0Curve;
					ID1 = NULL;
					break;
				case	Store:
					MOPu = StoreInstructionOPu.u;
					SOPu = StoreInstructionOPu.o;
					MOPo = StoreInstructionOPo.u;
					SOPo = StoreInstructionOPo.o;
					MOPKu = StoreInstructionOPKu.u;
					SOPKu = StoreInstructionOPKu.o;
					MOPKo = StoreInstructionOPKo.u;
					SOPKo = StoreInstructionOPKo.o;
					MOPCu = StoreInstructionOPCu.u;
					SOPCu = StoreInstructionOPCu.o;
					MOPCo = StoreInstructionOPCo.u;
					SOPCo = StoreInstructionOPCo.o;
					ID0 = StoreI0Curve;
					ID1 = StoreI1Curve;
					break;
				case	Branch:
					MOPu = BranchInstructionOPu.u;
					SOPu = BranchInstructionOPu.o;
					MOPo = BranchInstructionOPo.u;
					SOPo = BranchInstructionOPo.o;
					MOPKu = BranchInstructionOPKu.u;
					SOPKu = BranchInstructionOPKu.o;
					MOPKo = BranchInstructionOPKo.u;
					SOPKo = BranchInstructionOPKo.o;
					MOPCu = BranchInstructionOPCu.u;
					SOPCu = BranchInstructionOPCu.o;
					MOPCo = BranchInstructionOPCo.u;
					SOPCo = BranchInstructionOPCo.o;
					MMu = BranchInstructionMu.u;
					SMu = BranchInstructionMu.o;
					MMo = BranchInstructionMo.u;
					SMo = BranchInstructionMo.o;
					ID0 = BranchI0Curve;
					ID1 = BranchI1Curve;
					break;
				//default:
				//	printf("WOWA: %d, %s/%d\n",
				//		b->Instructions[Index2].FunctionalUnitRequirements, __FILE__, __LINE__);
				}
			if(MOPu >= 0.0)
				{
				// set OutcomePredictability
				x = -1;
				while( (x<0.0)||(x>1.0) )
					{	
					x = RandomVariable :: GetNormalRandomVariable(MOPu, SOPu);
					}
				b->Instructions[Index2].OutcomePredictability.u = x;
				x = -1;
				while( (x<0.0)||(x>1.0) )
					{	
					x = RandomVariable :: GetNormalRandomVariable(MOPo, SOPo);
					}
				b->Instructions[Index2].OutcomePredictability.o = x;
				}
			if(MOPCu >= 0.0)
				{
				// set OutcomePredictability - Knowledge
				x = -1;
				while( (x<0.0)||(x>1.0) )
					{	
					x = RandomVariable :: GetNormalRandomVariable(MOPKu, SOPKu);
					}
				b->Instructions[Index2].OutcomeKnowledge.u = x;
				x = -1;
				while( (x<0.0)||(x>1.0) )
					{	
					x = RandomVariable :: GetNormalRandomVariable(MOPKo, SOPKo);
					}
				b->Instructions[Index2].OutcomeKnowledge.o = x;
				}
			if(MOPCu >= 0.0)
				{
				// set OutcomePredictability - Confidence
				x = -1;
				while( (x<0.0)||(x>1.0) )
					{	
					x = RandomVariable :: GetNormalRandomVariable(MOPCu, SOPCu);
					}
				b->Instructions[Index2].OutcomeConfidence.u = x;
				x = -1;
				while( (x<0.0)||(x>1.0) )
					{	
					x = RandomVariable :: GetNormalRandomVariable(MOPCo, SOPCo);
					}
				b->Instructions[Index2].OutcomeConfidence.o = x;
				}
			if(MMu >= 0.0)
				{
				// set Memoizability
				x = -1;
				while( (x<0.0)||(x>1.0) )
					{	
					x = RandomVariable :: GetNormalRandomVariable(MMu, SMu);
					}
				b->Instructions[Index2].Memoizability.u = x;
				x = -1;
				while( (x<0.0)||(x>1.0) )
					{	
					x = RandomVariable :: GetNormalRandomVariable(MMo, SMo);
					}
				b->Instructions[Index2].Memoizability.o = x;
				}
			// Set L1 I cache behavior
			x = -1;
			while( x < 0.0 )
				{
				x = RandomVariable :: GetNormalRandomVariable(L1IHu);
				}
			b->Instructions[Index2].L1InstructionHitPredictability.u = x;
			x = -1;
			while( x < 0.0 )
				{
				x = RandomVariable :: GetNormalRandomVariable(L1IHo);
				}
			b->Instructions[Index2].L1InstructionHitPredictability.o = x;
			// Set L2 I cache behavior
			x = -1;
			while( x < 0.0 )
				{
				x = RandomVariable :: GetNormalRandomVariable(L2IHu);
				}
			b->Instructions[Index2].L2InstructionHitPredictability.u = x;
			x = -1;
			while( x < 0.0 )
				{
				x = RandomVariable :: GetNormalRandomVariable(L2IHo);
				}
			b->Instructions[Index2].L2InstructionHitPredictability.o = x;
			if ( (b->Instructions[Index2].FunctionalUnitRequirements == Load) ||
				 (b->Instructions[Index2].FunctionalUnitRequirements == Store) )
				{
				// Set L1 D cache behavior
				x = -1;
				while( x < 0.0 )
					{
					x = RandomVariable :: GetNormalRandomVariable(L1DHu);
					}
				b->Instructions[Index2].L1DataHitPredictability.u = x;
				x = -1;
				while( x < 0.0 )
					{
					x = RandomVariable :: GetNormalRandomVariable(L1DHo);
					}
				b->Instructions[Index2].L1DataHitPredictability.o = x;
				// Set L2 D cache behavior
				x = -1;
				while( x < 0.0 )
					{
					x = RandomVariable :: GetNormalRandomVariable(L2DHu);
					}
				b->Instructions[Index2].L2DataHitPredictability.u = x;
				x = -1;
				while( x < 0.0 )
					{
					x = RandomVariable :: GetNormalRandomVariable(L2DHo);
					}
				b->Instructions[Index2].L2DataHitPredictability.o = x;
				}

			// Finally create input dependencies
			if ( ID0 )
				{
				Temp = 0;
				while ( Temp < 10 )
					{
					++Temp;
					b->Instructions[Index2].InputDependencies[0] = CreateInputDependence(ID0);
					if(b->Instructions[Index2].InputDependencies[0] > (Index2+1))
						break;	// past basic block, just break, who knows
					if(b->Instructions[Index2].InputDependencies[0] == 0)
						break;
					if(b->Instructions[Index2].InputDependencies[0] == (Index2+1))
						continue;	// not dependent upon branch.. redo it
					if(b->Instructions[ Index2 - b->Instructions[Index2].InputDependencies[0] ].
						FunctionalUnitRequirements == Store)
						continue;
					break;
					}
				}
			if ( ID1 )
				{
				Temp = 0;
				while ( Temp < 10 )
					{
					++Temp;
					b->Instructions[Index2].InputDependencies[1] = CreateInputDependence(ID1);
					if(b->Instructions[Index2].InputDependencies[1] > (Index2+1))
						break;	// past basic block, just break, who knows
					if(b->Instructions[Index2].InputDependencies[1] == 0)
						break;
					if(b->Instructions[Index2].InputDependencies[1] == (Index2+1))
						continue;	// not dependent upon branch.. redo it
					if(b->Instructions[ Index2 - b->Instructions[Index2].InputDependencies[1] ].
						FunctionalUnitRequirements == Store)
						continue;
					break;
					}
				}
			++Index2;
			}
		++Index;
		}


	return(BasicBlocks[0]);
	}

bool
DumpBasicBlock (
	FILE		*fp,
	BasicBlock	*b)
	{
	fprintf(fp, "Basic Block : %8.8x\n", b);
	fprintf(fp, "\tNumberOfInstructions   : %d\n", b->NumberOfInstructions);
	fprintf(fp, "\tBranchTargets[0]       : %8.8x\n", b->BranchTargets[0]);
	fprintf(fp, "\tBranchTargets[1]       : %8.8x\n", b->BranchTargets[1]);
	fprintf(fp, "\tOutcomePredictability  : u=%f o=%f\n",
		b->OutcomePredictability.u, b->OutcomePredictability.o);
	fprintf(fp, "\tBranchPredictability   : l=%f\n",
		b->BranchPredictability);
	int	Index = 0;
	while ( Index < b->NumberOfInstructions )
		{
		switch ( b->Instructions[Index].FunctionalUnitRequirements )
			{
			case	Integer:		fprintf(fp, "\t\t[Integer] : ");break;
			case	FloatingPoint:	fprintf(fp, "\t\t[FP     ] : ");break;
			case	Load:			fprintf(fp, "\t\t[Load   ] : ");break;
			case	Store:			fprintf(fp, "\t\t[Store  ] : ");break;
			}
		fprintf(fp, "OP u=%f o=%f : ",
			b->Instructions[Index].OutcomePredictability.o,
			b->Instructions[Index].OutcomePredictability.u);
		fprintf(fp, "I0D=%d I1D=%d\n",
			b->Instructions[Index].InputDependencies[0],
			b->Instructions[Index].InputDependencies[1]);
		++Index;
		}
	return ( true );
	}

