
class	CompletionUnit;

class	DispatchUnit
	{
	public:
		int			WindowSize;
		Instruction	*Instructions;
		uint		*Addresses;
		int			Valid;
		int64		InstructionCount;
		int			MaxDispatchAmount;
		CompletionUnit	*theCompletionUnit;

		bool		Initialize (
						int	aWindowSize,
						int	aMaxDispatchAmount,
						CompletionUnit	*cu);

		bool		AddInstructions(
						Instruction		*aInstructions,
						uint			*aAddresses,
						uint			Size);

		bool		SimulateOneClock(
						Instruction		*aIntegerInstructions,
						uint			*aIntegerAddresses,
						Instruction		*aFPInstructions,
						uint			*aFPAddresses,
						Instruction		*aLoadInstructions,
						uint			*aLoadAddresses,
						Instruction		*aStoreInstructions,
						uint			*aStoreAddresses,
						Instruction		*aBranchInstructions,
						uint			*aBranchAddresses,
						int				*MDSInteger,
						int				*MDSFP,
						int				*MDSLoad,
						int				*MDSStore,
						int				*MDSBranch );

		bool		Flush (int64	aInstructionCount);

		int			FreeSlots ();

		bool		Dump ();
	};
		

