
enum	FunctionalUnit
	{
	Integer = 1,
	FloatingPoint,
	Load,
	Store,
	Branch
	};

#	define	MaxInputDependencies	2
#	define	MaxBranchTargets		2

typedef	struct	_Instruction
	{
		FunctionalUnit			FunctionalUnitRequirements;
								// dynamic n inst. back
		int						InputDependencies[MaxInputDependencies];
		int64					InstructionCount;
		// Various distribution parameters
		NormalDistribution		OutcomePredictability;
		NormalDistribution		OutcomeKnowledge;
		NormalDistribution		OutcomeConfidence;
		NormalDistribution		Memoizability;
		NormalDistribution		L1InstructionHitPredictability;
		NormalDistribution		L2InstructionHitPredictability;
		NormalDistribution		L1DataHitPredictability;
		NormalDistribution		L2DataHitPredictability;
		bool					IsJump;
		bool					IsAMissSpeculationDueToBranch;
		bool					IsAMissSpeculationDueToData;
		bool					Memoizable;
		bool					MissPredictedOutcome;
		int						ExecutionState;
		uint					FixupTarget;
		double					OutcomePredictionConfidence;
	}	Instruction;

typedef	struct	_BasicBlock
	{
	public:
		uint					Address;
		uint					NumberOfInstructions;
		Instruction				*Instructions;
		struct	_BasicBlock		*BranchTargets[MaxBranchTargets];
		NormalDistribution		OutcomeConfidence;
		NormalDistribution		OutcomePredictability;
		NormalDistribution		MemoizabilityOfBranch;
		NormalDistribution		BranchPredictability;
//		double					BranchPredictability;
		int						BranchInputDependencies[MaxInputDependencies];
		struct	_BasicBlock		*Next;
	}	BasicBlock;

BasicBlock	*CreateInputCode ();
bool		DumpBasicBlock(FILE	*, BasicBlock	*);

