#	include	"Standard.h"

double	RandomSeed				=	1.0;
bool	CalibrateSimulator		=	false;
int	MaxInstructionFetchAmount	=	16;
int	L1MissPenalty				=	20;
int	L2MissPenalty				=	200;
int	DispatchWindowSize			=	64;
int	IntegerUnits				=	4;
int	FPUnits						=	1;
int	LoadUnits					=	4;
int	StoreUnits					=	4;
int	BranchUnits					=	1;
int	IntegerQueueSize			=	16;
int	FPQueueSize					=	4;
int	LoadQueueSize				=	16;
int	StoreQueueSize				=	16;
int	BranchQueueSize				=	4;
int	IntegerPipelineDelay		=	1;
int	FPPipelineDelay				=	2;
int	LoadPipelineDelay			=	2;
int	StorePipelineDelay			=	2;
int	BranchPipelineDelay			=	1;
int	MaxCompletionsPerCycle		=	4;
int	MaxInstructionDispatchAmount	=	16;

int64	MaxCycles				=	10000;
extern	int	StallPenaltyForBranchMissPredict;
extern	int	StallPenaltyForValueMissPredict;

extern	int		NumberOfBasicBlocks;
extern	NormalDistribution	ForwardBlockJumpDistance;
extern	NormalDistribution	BackBlockJumpDistance;
extern	double	AverageNumberOfBackBranches;
//extern	ExponentialDistribution	ForwardBranchPredictability;
//extern	ExponentialDistribution	BackwardBranchPredictability;
extern	NormalDistribution	ForwardBranchPredictabilityu;
extern	NormalDistribution	ForwardBranchPredictabilityo;
extern	NormalDistribution	BackwardBranchPredictabilityu;
extern	NormalDistribution	BackwardBranchPredictabilityo;
extern	NormalDistribution	BasicBlockSize;

extern	NormalDistribution	L1IHu;
extern	NormalDistribution	L2IHu;
extern	NormalDistribution	L1IHo;
extern	NormalDistribution	L2IHo;
extern	NormalDistribution	L1DHu;
extern	NormalDistribution	L2DHu;
extern	NormalDistribution	L1DHo;
extern	NormalDistribution	L2DHo;

extern	double	PercentInteger;
extern	double	PercentFloating;
extern	double	PercentLoad;
extern	double	PercentStore;
extern	double	PercentBranch;

extern	NormalDistribution	IntegerInstructionOPu;
extern	NormalDistribution	IntegerInstructionOPo;
extern	NormalDistribution	LoadInstructionOPu;
extern	NormalDistribution	LoadInstructionOPo;
extern	NormalDistribution	StoreInstructionOPu;
extern	NormalDistribution	StoreInstructionOPo;
extern	NormalDistribution	FPInstructionOPu;
extern	NormalDistribution	FPInstructionOPo;
extern	NormalDistribution	BranchInstructionOPu;
extern	NormalDistribution	BranchInstructionOPo;

extern	NormalDistribution	IntegerInstructionOPKu;
extern	NormalDistribution	IntegerInstructionOPKo;
extern	NormalDistribution	LoadInstructionOPKu;
extern	NormalDistribution	LoadInstructionOPKo;
extern	NormalDistribution	StoreInstructionOPKu;
extern	NormalDistribution	StoreInstructionOPKo;
extern	NormalDistribution	FPInstructionOPKu;
extern	NormalDistribution	FPInstructionOPKo;
extern	NormalDistribution	BranchInstructionOPKu;
extern	NormalDistribution	BranchInstructionOPKo;

extern	NormalDistribution	IntegerInstructionOPCu;
extern	NormalDistribution	IntegerInstructionOPCo;
extern	NormalDistribution	LoadInstructionOPCu;
extern	NormalDistribution	LoadInstructionOPCo;
extern	NormalDistribution	StoreInstructionOPCu;
extern	NormalDistribution	StoreInstructionOPCo;
extern	NormalDistribution	FPInstructionOPCu;
extern	NormalDistribution	FPInstructionOPCo;
extern	NormalDistribution	BranchInstructionOPCu;
extern	NormalDistribution	BranchInstructionOPCo;

extern	NormalDistribution	IntegerInstructionMu;
extern	NormalDistribution	IntegerInstructionMo;
extern	NormalDistribution	FPInstructionMu;
extern	NormalDistribution	FPInstructionMo;
extern	NormalDistribution	BranchInstructionMu;
extern	NormalDistribution	BranchInstructionMo;

extern	char	DependenceCurveFile[];

extern	NormalDistribution	TraceCacheBasicBlockContinueRate;

extern	double	ValuePredictionConfidenceThreshold;

CommandLineArgument	CommandLineArguments[]	=
	{
		{	"RandomSeed",					claDouble,	&RandomSeed	},
		{	"CalibrateSimulator",			claBool,	&CalibrateSimulator	},
		{	"MaxInstructionFetchAmount",	claInteger,	&MaxInstructionFetchAmount	},
		{	"MaxInstructionDispatchAmount",	claInteger,	&MaxInstructionDispatchAmount	},
		{	"MaxCompletionsPerCycle",		claInteger,	&MaxCompletionsPerCycle	},
		{	"L1MissPenalty",				claInteger,	&L1MissPenalty	},
		{	"L2MissPenalty",				claInteger,	&L2MissPenalty	},
		{	"DispatchWindowSize",			claInteger,	&DispatchWindowSize	},
		{	"IntegerUnits",					claInteger,	&IntegerUnits	},
		{	"FPUnits",						claInteger,	&FPUnits		},
		{	"LoadUnits",					claInteger,	&LoadUnits		},
		{	"StoreUnits",					claInteger,	&StoreUnits		},
		{	"BranchUnits",					claInteger,	&BranchUnits	},
		{	"IntegerQueueSize",				claInteger,	&IntegerQueueSize	},
		{	"FPQueueSize",					claInteger,	&FPQueueSize	},
		{	"LoadQueueSize",				claInteger,	&LoadQueueSize	},
		{	"StoreQueueSize",				claInteger,	&StoreQueueSize	},
		{	"BranchQueueSize",				claInteger,	&BranchQueueSize	},
		{	"IntegerPipelineDelay",			claInteger,	&IntegerPipelineDelay	},
		{	"FPPipelineDelay",				claInteger,	&FPPipelineDelay	},
		{	"LoadPipelineDelay",			claInteger,	&LoadPipelineDelay	},
		{	"StorePipelineDelay",			claInteger,	&StorePipelineDelay	},
		{	"BranchPipelineDelay",			claInteger,	&BranchPipelineDelay	},
		{	"MaxCycles",					claInt64,	&MaxCycles	},
		{	"StallPenaltyForBranchMissPredict", claInteger, &StallPenaltyForBranchMissPredict },
		{	"StallPenaltyForValueMissPredict", claInteger, &StallPenaltyForValueMissPredict },
		{	"NumberOfBasicBlocks",			claInteger,	&NumberOfBasicBlocks	},
		{	"ForwardBlockJumpDistance.u",	claDouble,	&ForwardBlockJumpDistance.u	},
		{	"ForwardBlockJumpDistance.o",	claDouble,	&ForwardBlockJumpDistance.o	},
		{	"BackBlockJumpDistance.u",		claDouble,	&BackBlockJumpDistance.u	},
		{	"BackBlockJumpDistance.o",		claDouble,	&BackBlockJumpDistance.o	},
		{	"AverageNumberOfBackBranches",	claDouble,	&AverageNumberOfBackBranches	},
		{	"ForwardBranchPredictabilityu.u",claDouble,	&ForwardBranchPredictabilityu.u	},
		{	"ForwardBranchPredictabilityu.o",claDouble,	&ForwardBranchPredictabilityu.o	},
		{	"ForwardBranchPredictabilityo.u",claDouble,	&ForwardBranchPredictabilityo.u	},
		{	"ForwardBranchPredictabilityo.o",claDouble,	&ForwardBranchPredictabilityo.o	},
		{	"BackwardBranchPredictabilityu.u", claDouble,&BackwardBranchPredictabilityu.u },
		{	"BackwardBranchPredictabilityu.o", claDouble,&BackwardBranchPredictabilityu.o },
		{	"BackwardBranchPredictabilityo.u", claDouble,&BackwardBranchPredictabilityo.u },
		{	"BackwardBranchPredictabilityo.o", claDouble,&BackwardBranchPredictabilityo.o },
//		{	"ForwardBranchPredictability.l",claDouble,	&ForwardBranchPredictability.l	},
//		{	"BackwardBranchPredictability.l", claDouble,&BackwardBranchPredictability.l },
		{	"BasicBlockSize.u",				claDouble,	&BasicBlockSize.u	},
		{	"BasicBlockSize.o",				claDouble,	&BasicBlockSize.o	},
		{	"L1IHu.u",						claDouble,	&L1IHu.u	},
		{	"L1IHu.o",						claDouble,	&L1IHu.o	},
		{	"L2IHu.u",						claDouble,	&L2IHu.u	},
		{	"L2IHu.o",						claDouble,	&L2IHu.o	},
		{	"L1IHo.u",						claDouble,	&L1IHo.u	},
		{	"L1IHo.o",						claDouble,	&L1IHo.o	},
		{	"L2IHo.u",						claDouble,	&L2IHo.u	},
		{	"L2IHo.o",						claDouble,	&L2IHo.o	},
		{	"L1DHu.u",						claDouble,	&L1DHu.u	},
		{	"L1DHu.o",						claDouble,	&L1DHu.o	},
		{	"L2DHu.u",						claDouble,	&L2DHu.u	},
		{	"L2DHu.o",						claDouble,	&L2DHu.o	},
		{	"L1DHo.u",						claDouble,	&L1DHo.u	},
		{	"L1DHo.o",						claDouble,	&L1DHo.o	},
		{	"L2DHo.u",						claDouble,	&L2DHo.u	},
		{	"L2DHo.o",						claDouble,	&L2DHo.o	},
		{	"PercentInteger",				claDouble,	&PercentInteger	},
		{	"PercentFloating",				claDouble,	&PercentFloating	},
		{	"PercentLoad",					claDouble,	&PercentLoad	},
		{	"PercentStore",					claDouble,	&PercentStore	},
		{	"PercentBranch",				claDouble,	&PercentBranch	},
		{	"IntegerInstructionOPu.u",		claDouble,	&IntegerInstructionOPu.u	},
		{	"IntegerInstructionOPu.o",		claDouble,	&IntegerInstructionOPu.o	},
		{	"IntegerInstructionOPo.u",		claDouble,	&IntegerInstructionOPo.u	},
		{	"IntegerInstructionOPo.o",		claDouble,	&IntegerInstructionOPo.o	},
		{	"FPInstructionOPu.u",			claDouble,	&FPInstructionOPu.u	},
		{	"FPInstructionOPu.o",			claDouble,	&FPInstructionOPu.o	},
		{	"FPInstructionOPo.u",			claDouble,	&FPInstructionOPo.u	},
		{	"FPInstructionOPo.o",			claDouble,	&FPInstructionOPo.o	},
		{	"LoadInstructionOPu.u",			claDouble,	&LoadInstructionOPu.u	},
		{	"LoadInstructionOPu.o",			claDouble,	&LoadInstructionOPu.o	},
		{	"LoadInstructionOPo.u",			claDouble,	&LoadInstructionOPo.u	},
		{	"LoadInstructionOPo.o",			claDouble,	&LoadInstructionOPo.o	},
		{	"StoreInstructionOPu.u",		claDouble,	&StoreInstructionOPu.u	},
		{	"StoreInstructionOPu.o",		claDouble,	&StoreInstructionOPu.o	},
		{	"StoreInstructionOPo.u",		claDouble,	&StoreInstructionOPo.u	},
		{	"StoreInstructionOPo.o",		claDouble,	&StoreInstructionOPo.o	},
		{	"BranchInstructionOPu.u",		claDouble,	&BranchInstructionOPu.u	},
		{	"BranchInstructionOPu.o",		claDouble,	&BranchInstructionOPu.o	},
		{	"BranchInstructionOPo.u",		claDouble,	&BranchInstructionOPo.u	},
		{	"BranchInstructionOPo.o",		claDouble,	&BranchInstructionOPo.o	},
		{	"IntegerInstructionOPKu.u",		claDouble,	&IntegerInstructionOPKu.u	},
		{	"IntegerInstructionOPKu.o",		claDouble,	&IntegerInstructionOPKu.o	},
		{	"IntegerInstructionOPKo.u",		claDouble,	&IntegerInstructionOPKo.u	},
		{	"IntegerInstructionOPKo.o",		claDouble,	&IntegerInstructionOPKo.o	},
		{	"FPInstructionOPKu.u",			claDouble,	&FPInstructionOPKu.u	},
		{	"FPInstructionOPKu.o",			claDouble,	&FPInstructionOPKu.o	},
		{	"FPInstructionOPKo.u",			claDouble,	&FPInstructionOPKo.u	},
		{	"FPInstructionOPKo.o",			claDouble,	&FPInstructionOPKo.o	},
		{	"LoadInstructionOPKu.u",		claDouble,	&LoadInstructionOPKu.u	},
		{	"LoadInstructionOPKu.o",		claDouble,	&LoadInstructionOPKu.o	},
		{	"LoadInstructionOPKo.u",		claDouble,	&LoadInstructionOPKo.u	},
		{	"LoadInstructionOPKo.o",		claDouble,	&LoadInstructionOPKo.o	},
		{	"StoreInstructionOPKu.u",		claDouble,	&StoreInstructionOPKu.u	},
		{	"StoreInstructionOPKu.o",		claDouble,	&StoreInstructionOPKu.o	},
		{	"StoreInstructionOPKo.u",		claDouble,	&StoreInstructionOPKo.u	},
		{	"StoreInstructionOPKo.o",		claDouble,	&StoreInstructionOPKo.o	},
		{	"BranchInstructionOPKu.u",		claDouble,	&BranchInstructionOPKu.u	},
		{	"BranchInstructionOPKu.o",		claDouble,	&BranchInstructionOPKu.o	},
		{	"BranchInstructionOPKo.u",		claDouble,	&BranchInstructionOPKo.u	},
		{	"BranchInstructionOPKo.o",		claDouble,	&BranchInstructionOPKo.o	},
		{	"IntegerInstructionOPCu.u",		claDouble,	&IntegerInstructionOPCu.u	},
		{	"IntegerInstructionOPCu.o",		claDouble,	&IntegerInstructionOPCu.o	},
		{	"IntegerInstructionOPCo.u",		claDouble,	&IntegerInstructionOPCo.u	},
		{	"IntegerInstructionOPCo.o",		claDouble,	&IntegerInstructionOPCo.o	},
		{	"FPInstructionOPCu.u",			claDouble,	&FPInstructionOPCu.u	},
		{	"FPInstructionOPCu.o",			claDouble,	&FPInstructionOPCu.o	},
		{	"FPInstructionOPCo.u",			claDouble,	&FPInstructionOPCo.u	},
		{	"FPInstructionOPCo.o",			claDouble,	&FPInstructionOPCo.o	},
		{	"LoadInstructionOPCu.u",		claDouble,	&LoadInstructionOPCu.u	},
		{	"LoadInstructionOPCu.o",		claDouble,	&LoadInstructionOPCu.o	},
		{	"LoadInstructionOPCo.u",		claDouble,	&LoadInstructionOPCo.u	},
		{	"LoadInstructionOPCo.o",		claDouble,	&LoadInstructionOPCo.o	},
		{	"StoreInstructionOPCu.u",		claDouble,	&StoreInstructionOPCu.u	},
		{	"StoreInstructionOPCu.o",		claDouble,	&StoreInstructionOPCu.o	},
		{	"StoreInstructionOPCo.u",		claDouble,	&StoreInstructionOPCo.u	},
		{	"StoreInstructionOPCo.o",		claDouble,	&StoreInstructionOPCo.o	},
		{	"BranchInstructionOPCu.u",		claDouble,	&BranchInstructionOPCu.u	},
		{	"BranchInstructionOPCu.o",		claDouble,	&BranchInstructionOPCu.o	},
		{	"BranchInstructionOPCo.u",		claDouble,	&BranchInstructionOPCo.u	},
		{	"BranchInstructionOPCo.o",		claDouble,	&BranchInstructionOPCo.o	},
		{	"IntegerInstructionMu.u",		claDouble,	&IntegerInstructionMu.u	},
		{	"IntegerInstructionMu.o",		claDouble,	&IntegerInstructionMu.o	},
		{	"IntegerInstructionMo.u",		claDouble,	&IntegerInstructionMo.u	},
		{	"IntegerInstructionMo.o",		claDouble,	&IntegerInstructionMo.o	},
		{	"FPInstructionMu.u",			claDouble,	&FPInstructionMu.u	},
		{	"FPInstructionMu.o",			claDouble,	&FPInstructionMu.o	},
		{	"FPInstructionMo.u",			claDouble,	&FPInstructionMo.u	},
		{	"FPInstructionMo.o",			claDouble,	&FPInstructionMo.o	},
		{	"BranchInstructionMu.u",		claDouble,	&BranchInstructionMu.u	},
		{	"BranchInstructionMu.o",		claDouble,	&BranchInstructionMu.o	},
		{	"BranchInstructionMo.u",		claDouble,	&BranchInstructionMo.u	},
		{	"BranchInstructionMo.o",		claDouble,	&BranchInstructionMo.o	},
		{	"DependenceCurveFile",			claString,	DependenceCurveFile },
		{	"TraceCacheBasicBlockContinueRate.u",	claDouble,	&TraceCacheBasicBlockContinueRate.u },
		{	"TraceCacheBasicBlockContinueRate.o",	claDouble,	&TraceCacheBasicBlockContinueRate.o },
		{	"ValuePredictionConfidenceThreshold",	claDouble,	&ValuePredictionConfidenceThreshold },
		{	NULL,							claInteger,	NULL }
	};


int
main(
	int		argc,
	char	*argv[])
	{
	BasicBlock	*Start;

	int	vargc = ParseCommandLine(CommandLineArguments, argc, argv);

	RandomVariable::InitializeRandomVariableGenerator(RandomSeed);
	Start = CreateInputCode();
	
	FetchUnit		theFetchUnit;
	DispatchUnit	theDispatchUnit;
	ExecutionUnit	theExecutionUnit;
	CompletionUnit	theCompletionUnit;

	theFetchUnit.Initialize (
		Start,					// code
		L1MissPenalty,			// l1 miss penalty
		L2MissPenalty			// l2 miss penalty
		);

	theDispatchUnit.Initialize (
		DispatchWindowSize,		// window size
		MaxInstructionDispatchAmount,
		&theCompletionUnit
		);

	theExecutionUnit.Initialize (
		IntegerUnits,			// integer units
		FPUnits,				// FP units
		LoadUnits,				// load units
		StoreUnits,				// store units
		BranchUnits,			// branch unit
		IntegerQueueSize,		// integer queue size
		FPQueueSize,			// FP queue size
		LoadQueueSize,			// load queue size
		StoreQueueSize,			// store queue size
		BranchQueueSize,		// branch queue size
		IntegerPipelineDelay,	// integer pipeline delay
		FPPipelineDelay,		// FP pipeline delay
		LoadPipelineDelay,		// load pipeline delay
		StorePipelineDelay,		// store pipeline delay
		BranchPipelineDelay,	// branch pipeline delay
		&theCompletionUnit,
		L1MissPenalty,
		L2MissPenalty
		);

	theCompletionUnit.Initialize (MaxCompletionsPerCycle);

	

	Instruction	*FetchInstructions = new Instruction[ MaxInstructionFetchAmount ];
	uint		*FetchAddresses = new uint[ MaxInstructionFetchAmount ];

	Instruction	*IntegerInstructions = new Instruction [ IntegerQueueSize ];
	uint		*IntegerAddresses = new uint[ IntegerQueueSize ];
	Instruction	*FPInstructions = new Instruction [ FPQueueSize ];
	uint		*FPAddresses = new uint[ FPQueueSize ];
	Instruction	*LoadInstructions = new Instruction [ LoadQueueSize ];
	uint		*LoadAddresses = new uint[ LoadQueueSize ];
	Instruction	*StoreInstructions = new Instruction [ StoreQueueSize ];
	uint		*StoreAddresses = new uint[ StoreQueueSize ];
	Instruction	*BranchInstructions = new Instruction [ BranchQueueSize ];
	uint		*BranchAddresses = new uint[ BranchQueueSize ];

	int			IntegerSlots, FPSlots, LoadSlots, StoreSlots, BranchSlots;
	int			nIntegerSlots, nFPSlots, nLoadSlots, nStoreSlots, nBranchSlots;
	
	int			Fetched;
	int			FreeDispatchSlots;
	bool		ResetBranch;
	uint		ToAddress;
	int64		ToCount;
	int64		CycleCount = 0;
	int64		RollBacks = 0;
	bool		ResetDueToBranch;
	int64		MissPredictedBranches = 0;
	int64		MissPredictedValues = 0;

	while ( CycleCount < MaxCycles )
		{
		theExecutionUnit.FreeSlots (
			&IntegerSlots, &FPSlots, &LoadSlots, &StoreSlots, &BranchSlots );
		FreeDispatchSlots = theDispatchUnit.FreeSlots();

		///////////////////////////////////////////////////////////////////////////
		//						Completion
		///////////////////////////////////////////////////////////////////////////

		theCompletionUnit.SimulateOneClock ();

		///////////////////////////////////////////////////////////////////////////
		//                      Execution
		///////////////////////////////////////////////////////////////////////////

		// simulate backwards
		theExecutionUnit.SimulateOneClock(&ResetBranch, &ToAddress, &ToCount, &ResetDueToBranch);
		if ( ResetBranch )
			{
			theDispatchUnit.Flush ( ToCount );
			theFetchUnit.ResetFetchProgramCounter( ToAddress );
			theExecutionUnit.Flush( ToCount );
			theCompletionUnit.Flush( ToCount );
			++RollBacks;
			if(ResetDueToBranch)
				{
				CycleCount += StallPenaltyForBranchMissPredict;
				++MissPredictedBranches;
				}
			else
				{
				CycleCount += StallPenaltyForValueMissPredict;
				++MissPredictedValues;
				}
			continue;
			}

		///////////////////////////////////////////////////////////////////////////
		//                      Dispatch
		///////////////////////////////////////////////////////////////////////////

		nIntegerSlots = IntegerSlots;
		nFPSlots = FPSlots;
		nLoadSlots = LoadSlots;
		nStoreSlots = StoreSlots;
		nBranchSlots = BranchSlots;

		theDispatchUnit.SimulateOneClock(
			IntegerInstructions, IntegerAddresses,
			FPInstructions, FPAddresses,
			LoadInstructions, LoadAddresses,
			StoreInstructions, StoreAddresses,
			BranchInstructions, BranchAddresses,
			&nIntegerSlots, &nFPSlots, &nLoadSlots, &nStoreSlots, &nBranchSlots );	
	
		// put instructions into execution unit.
		theExecutionUnit.AddInstructions (
			IntegerInstructions, IntegerAddresses, IntegerSlots - nIntegerSlots,
			FPInstructions, FPAddresses, FPSlots - nFPSlots,
			LoadInstructions, LoadAddresses, LoadSlots - nLoadSlots,
			StoreInstructions, StoreAddresses, StoreSlots - nStoreSlots,
			BranchInstructions, BranchAddresses, BranchSlots - nBranchSlots );
	
		///////////////////////////////////////////////////////////////////////////
		//                      Fetch
		///////////////////////////////////////////////////////////////////////////

		if ( FreeDispatchSlots > MaxInstructionFetchAmount )
			FreeDispatchSlots = MaxInstructionFetchAmount;

		theFetchUnit.SimulateOneClock(FetchInstructions,
			FetchAddresses, &Fetched, FreeDispatchSlots);

		/*
		printf("Fetched = %d of %d ", Fetched, FreeDispatchSlots);
		printf("Dispatched I: %d of %d F: %d of %d L: %d of %d S: %d of %d B: %d of %d\n",
			IntegerSlots - nIntegerSlots, IntegerSlots,
			FPSlots - nFPSlots, FPSlots,
			LoadSlots - nLoadSlots, LoadSlots,
			StoreSlots - nStoreSlots, StoreSlots,
			BranchSlots - nBranchSlots, BranchSlots);
		*/	

		theDispatchUnit.AddInstructions(FetchInstructions, FetchAddresses, Fetched);
		++CycleCount;
		}

	double	Ins = theCompletionUnit.Completed;
	double	Cycles = CycleCount;

	if(!CalibrateSimulator)
		{
		printf("%f\n", (double)Ins/Cycles);
		}
	else
		{
		printf("IPC: %f\n", (double)Ins/Cycles);
		printf("Instruction Completions: %lld\n", theCompletionUnit.Completed);
		printf("Cycles: %lld\n", CycleCount);
		printf("Predictions: %lld\n", theCompletionUnit.PredictionCount);
		printf("Flushes/Roll-backs: %lld\n", RollBacks);
		printf("Miss predicted branches: %lld\n", MissPredictedBranches);
		printf("Miss predicted value: %lld\n", MissPredictedValues);
		printf("Branch Prediction: Correct: %lld Incorrect %lld, Correct-Rate: %.3f\n",
			theFetchUnit.CorrectBranchPredictions,
			theFetchUnit.IncorrectBranchPredictions,
			((double)theFetchUnit.CorrectBranchPredictions)/
			((double)(theFetchUnit.CorrectBranchPredictions + theFetchUnit.IncorrectBranchPredictions))
			);
		}

	//theDispatchUnit.Dump();
	//theExecutionUnit.Dump();
	FILE	*fp = fopen("param.out", "w");
	DumpParameters(CommandLineArguments, fp);
	fclose(fp);

	return(0);
	}
